(	
global AM_Rollout
try (destroydialog AM_Rollout)catch()
	
local RE = undefined
local metaName = undefined
local firstElement = undefined
local elementNum = 0
local cameraTilt = undefined
local cameraHorizTilt = undefined
local cameraVertTilt = undefined
local cameraISO = undefined
local standardCheck = undefined
local targetCheck = undefined
local domeCameraCheck = undefined
local phsyicalCameraCheck = undefined
local activeCamera = undefined
local cameraShift = undefined
local cameraHorizShift = undefined
local cameraVertShift = undefined
local cameraWBTemp = undefined
local customData = undefined
local elementCheck = undefined
local elementLast = undefined
local vrayCameraCheck = undefined
global printMetadata = undefined
global addSeqMetadata = undefined
local addMetadata = undefined
	
	rollout AM_Rollout "Add Metadata to .exr"
(
	button 'btn1' "Add Metadata" pos:[10,195] width: 215 height: 40 align:#center tooltip:"This script adds metadata to .exrs through VRayOptionRE. Select an active physical camera view (both V-Ray and 3ds Max native work), choose the data you wish to store and run. Read the parameter tooltips for more information."
	edittext 'edt1' "Custom Metadata" pos: [10,130] text: "" width: 215 height: 20 align:#right labelontop: true enabled: false
	groupBox 'group1' "Camera Data" pos: [10, 10] width:105 height:115
	groupBox 'group2' "Custom Data" pos: [120, 10] width:105 height:115
	checkbox 'iso' "ISO" pos:[20,30] checked:false enabled: true
	checkbox 'tlt' "Tilt" pos:[20,70] checked:false enabled: true
	checkbox 'shft' "Shift" pos:[20,90] checked:false enabled: true
	checkbox 'wb' "White balance" pos:[20,50] checked:false enabled: true tooltip: "Presets are ignored. The value is taken from the Temperature in Kelvin parameter."
	checkbox 'cust' "Custom" pos: [130,30] checked: false
	checkbox 'seq' "Sequence" pos: [155, 175] checked: false tooltip: "Checking this will add a preRenderFrame callback script. You MUST click the button afterward."
	
	
	fn printMetadata =(
		-- warning checks
			fn isVRayCurrent = matchPattern (renderers.current as string) pattern:"*V_RAY*"
			if isVRayCurrent() == true then print "Okay." else return messageBox "V-Ray is not set to current renderer!" title: "Error"
			activeCamera = getActiveCamera()
			if activeCamera != undefined then print "Okay." else return messageBox "Select an active Physical Camera view!" title: "Error"
			standardCheck = matchPattern (activeCamera as string) pattern:"*Free_Camera*"
			targetCheck = matchPattern (activeCamera as string) pattern:"*Target_Camera*"
			domeCameraCheck = matchPattern (activeCamera as string) pattern:"*VRayDomeCamera*"
			physicalCameraCheck = matchPattern (activeCamera as string) pattern:"*Physical_Camera*"
			vrayCameraCheck = matchPattern (activeCamera as string) pattern:"*VRayPhysicalCamera*"
			if standardCheck == true or targetCheck == true or domeCameraCheck == true then return messageBox "Select an active Physical Camera view!" title: "Error"
		
		--get data depending on 3ds Max or V-Ray physical camera
		RE = maxOps.GetCurRenderElementMgr()
		metaName = ""
		if physicalCameraCheck == true then cameraHorizTilt = "cameraHorizTilt=" + (activeCamera.horizontal_tilt_correction as string) else cameraHorizTilt = "cameraHorizTilt=" + (activeCamera.lens_horTilt as string)
		if physicalCameraCheck == true then cameraVertTilt = "cameraVertTilt=" + (activeCamera.vertical_tilt_correction as string) else cameraVertTilt = "cameraVertTilt=" + (activeCamera.lens_tilt as string)
		cameraHorizShift = "cameraHorizShift=" + (activeCamera.horizontal_shift as string)
		cameraVertShift = "cameraVertShift=" + (activeCamera.vertical_shift as string)
		cameraShift = cameraHorizShift + ";" + cameraVertShift
		cameraTilt = cameraVertTilt + ";" + cameraHorizTilt
		cameraISO = "cameraISO=" + (activeCamera.ISO as string)
		customData = edt1.text
		if physicalCameraCheck == true then cameraWBTemp = "cameraWBTemp=" + (activeCamera.white_balance_kelvin as string)
		if vrayCameraCheck == true then cameraWBTemp = "cameraWBTemp=" + (activeCamera.temperature as string)
		
		--separate metadata with semicolons
		if tlt.checked == true or cust.checked == true or wb.checked == true or shft.checked == true then append cameraISO ";"
		if cust.checked == true  or tlt.checked == true or shft.checked == true then append cameraWBTemp ";"
		if cust.checked == true or shft.checked == true then append cameraTilt ";"
		if cust.checked == true then append cameraShift ";"
		
		-- unify metadata info
		if iso.checked == true then append metaname cameraISO
		if wb.checked == true then append metaName cameraWBTemp
		if tlt.checked == true then append metaName cameraTilt
		if shft.checked == true then append metaName cameraShift
		if cust.checked == true then append metaName customData
			
		print metaName
	)
	fn addMetadata =(
		-- VRayOptionRE check and metadata import
		if RE.NumRenderElements() == 0 then 
			( 
			RE.addRenderElement (VRayOptionRE elementname: "Metadata")
			local firstElement = RE.GetRenderElement 0
			firstElement.exr_metadata=metaName
			)
		else
			(
			local elementNum = RE.NumRenderElements() - 1
			local elementCheck = matchpattern (RE.GetRenderElement elementNum as string) pattern:"*VRayOptionRE*"
			local elementLast = RE.GetRenderElement elementNum
			if elementCheck == true then (
				RE.RemoveRenderElement elementLast
				RE.addRenderElement (VRayOptionRE elementname:"Metadata")
				elementNum = RE.NumRenderElements() - 1
				(RE.GetRenderElement elementnum).exr_metadata=metaName
			)
			else (			
			RE.addRenderElement (VRayOptionRE elementname: "Metadata")
			elementNum = RE.NumRenderElements() - 1
			(RE.GetRenderElement elementNum).exr_metadata=metaName
			)
			)
	)
		
	on cust changed state do (
		case state of (
		true: (
			edt1.enabled = true
		)
		false: (
			edt1.enabled = false
		)
	)
	)
	on seq changed state do (
		case state of (
		true: (
		fn addSeqMetadata =(
			metaName = printMetadata()
			local RE = maxOps.GetCurRenderElementMgr()
			local elementNum = RE.NumRenderElements() - 1
			(RE.GetRenderElement elementNum).exr_metadata=metaName			
			)
			callbacks.addScript #preRenderFrame "addSeqMetadata()" id:#addSeqMetadata
			print "preRenderFrame callback script added."
		)
		false: (
			callbacks.removeScripts #preRenderFrame id:#addSeqMetadata
			print "preRenderFrame callback script removed."
		)
	)
	)
	
	on btn1 pressed do 
	(
	printMetadata()
	if metaName != undefined then addMetadata()
	)
)
		createDialog AM_Rollout 235 245
)